#define PROG_VERSION 8




#define MICROCHIP_C18 0

#define DISP_ZEILE_LAENGE 16
#define DISP_ZEILEN_ANZAHL 2




#define DISPLAYTECH162_SET_Comand0_Daten1        LATCbits.LATC0
#define DISPLAYTECH162_SET_EnablePin LATCbits.LATC1
#define DISPLAYTECH162_SET_DataBit4  LATCbits.LATC2
#define DISPLAYTECH162_SET_DataBit5  LATCbits.LATC3
#define DISPLAYTECH162_SET_DataBit6  LATCbits.LATC4
#define DISPLAYTECH162_SET_DataBit7  LATCbits.LATC5
#define DISPLAYTECH162_DataBit4_DEF_In1_Out0  TRISCbits.TRISC2
#define DISPLAYTECH162_DataBit5_DEF_In1_Out0  TRISCbits.TRISC3
#define DISPLAYTECH162_DataBit6_DEF_In1_Out0  TRISCbits.TRISC4
#define DISPLAYTECH162_DataBit7_DEF_In1_Out0  TRISCbits.TRISC5
#define DISPLAYTECH162_DatenComand_DEF_In1_Out0   TRISCbits.TRISC0
    //Display Anschlusse fr TastenMatrix umdefinieren
#define TASTE0inMATRIXREIHE PORTCbits.RC2
#define TASTE1inMATRIXREIHE PORTCbits.RC3
#define TASTE2inMATRIXREIHE PORTCbits.RC4
#define TASTE3inMATRIXREIHE PORTCbits.RC5
#define TASTE0inMATRIXREIHE_PIN DISPLAYTECH162_DataBit4_DEF_In1_Out0
#define TASTE1inMATRIXREIHE_PIN DISPLAYTECH162_DataBit5_DEF_In1_Out0
#define TASTE2inMATRIXREIHE_PIN DISPLAYTECH162_DataBit6_DEF_In1_Out0
#define TASTE3inMATRIXREIHE_PIN DISPLAYTECH162_DataBit7_DEF_In1_Out0
#define TASTENMATRIXADRESSE0_PIN DISPLAYTECH162_DatenComand_DEF_In1_Out0
#define TASTENMATRIXADRESSE0 DISPLAYTECH162_SET_Comand0_Daten1
#define TASTENMATRIXADRESSE1_PIN TRISBbits.TRISB0
#define TASTENMATRIXADRESSE1 LATBbits.LATB0


#define DATEN_FUER_DISPLAY_ENABLE 1
#define DATEN_FUER_DISPLAY_NO_ENABLE 0
#define DATEN_FUER_DISPLAY_ALS_COMMAND 0
#define DATEN_FUER_DISPLAY_ALS_ZEICHEN 1
#define PIN_ALS_AUSGANG 0
#define PIN_ALS_EINGANG 1

#if    MICROCHIP_C18
	#define __dataSDCC
	#include <p18cxxx.h>
	#include "delays.h"                        // fr die Warteschleife
	#include "stdio.h"
	#include "stdlib.h"
	#include "string.h"
	#include "float.h"
	/** Configuration ********************************************************/
	#pragma config OSC = HS   //CPU=20 MHz
	#pragma config PWRT = ON
	//#pragma config BOR = OFF
	#pragma config WDT = OFF  //Watchdog Timer
	#pragma config LVP = OFF  //Low Voltage ICSP

	#pragma config WRTD = OFF  //


	void InterruptHigh(void); //interrupt 1
	#pragma code high_vector=0x08
	void interrupt_at_high_vector(void)
	{
 	_asm GOTO InterruptHigh _endasm
	}

	void InterruptLow(void); //interrupt 2
	#pragma code low_vector=0x18
	void interrupt_at_low_vector(void)
	{
 	_asm GOTO InterruptLow _endasm
	}
	#define delay1ktcy Delay1KTCYx
	#define delay10tcy Delay10TCYx
	#define __code  rom
	#define __data unsigned
#else
	#define __dataSDCC __data
	#include <PIC18fregs.h>
	//#include "p18f458.h"
	#include <delay.h>                       //fr die Warteschleife
	#include "ConfigDef.h"
	#include "stdio.h"
	#include "string.h"
	#include "c:\Program Files\sdcc\include\pic16\stdlib.h"
	//#include "stdlib.h"
/*code char at __CONFIG1L conf1L = USBDIV_USBclockDirectlyFromPrimaryOscillatorWithNoPostscale|
				 CPUDIV_ForXT_HS_EC_ECIO__PrimaryOscillatorDividedBy_1_ToDeriveSystemCloc  |
				 PLLDIV_PLLPrescalerBei20MhzDivideBy_5;*/
/*
#define __CONFIG1H              0x300001
#define __CONFIG2L              0x300002
#define __CONFIG2H              0x300003
#define __CONFIG3H              0x300005
#define __CONFIG4L              0x300006
#define __CONFIG5L              0x300008
#define __CONFIG5H              0x300009
#define __CONFIG6L              0x30000A
#define __CONFIG6H              0x30000B
#define __CONFIG7L              0x30000C
#define __CONFIG7H              0x30000D

*/

__code  __at __CONFIG1H char conf1H = OSC_HSOscillator | NO_IESO_OscillatorSwitchOver | FCMEN_FailSafeClockMonitor; // CPU=20 MHz


 //__code  __at __CONFIG2L  conf2L = (BOR_BrownOutResetDisabled | PWRT_PowerUpTimerEnable);

 //__code  __at __CONFIG2H char conf2H = NO_WDT_WatchdogEnable | WDTPS_WatchdogPostscale_32K768;

__code  __at __CONFIG2L  unsigned short conf2H_conf2L =((unsigned short)(NO_WDT_WatchdogEnable | WDTPS_WatchdogPostscale_32K768)<<8)|
                                                                  (BOR_BrownOutResetDisabled | PWRT_PowerUpTimerEnable);


/*__code char __at __CONFIG3H conf3H = MCLRE_PIN_Enable | NO_LPT1OSC_Timer1ConfiguredForLowPowerOperation	 |
			  PBADEN_PORTB_0_1_2_3_ConfiguredAsDigitalOnReset;*/

__code char __at __CONFIG4L conf4L = NO_DEBUG_BackgroundDebuggerEnable | XINST_ExtendedInstructionEnable|
				 NO_LVP_SingleSupplyICSP | STVREN_ResetBeiStackOverFlow;
	void InterruptHigh(void) __interrupt 1;
	void InterruptLow(void) __interrupt 2;

#endif








void Timer0Init(void);
void InterrupInit(void);
void DISPLAYTECH162_Init(void);
void DISPLAYTECH162_Enable(void);
void DISPLAYTECH162_Command(unsigned char command);
void DISPLAYTECH162_Data(unsigned char zeichen);
void Display_In_Interrupt();
unsigned char MatrixTastenZeileInterrupt[2];
unsigned char MatrixTastenZeile[2];
unsigned char MatrixTastenZeileAlt[2];
unsigned char MatrixTastenZeilePlusFlanke[2];
unsigned char MatrixTastenZeileMinusFlanke[2];
void MemsetEigene(char *Ziel,char Zeichen,unsigned char Anzahl);







unsigned char Flanke10MsT;
unsigned char Flanke100MsT;
unsigned char Flanke1000MsT;
unsigned char InterrupptZaehler;
unsigned char InterrupptZaehler1;
unsigned char InterrupptZaehler2;
unsigned char DisplayIn_Interrupt_Schritt;
unsigned char DisplayIn_Interrupt_ZeileNr;
unsigned char DisplayIn_Interrupt_ZeichenNr;
unsigned char DisplayIn_Interrupt_Zeichen;
unsigned char CursorAufPosInZeileNr;
unsigned char EditBlinkZaehler;
unsigned char CursorAufPos;
unsigned char DisplayZeileRam[DISP_ZEILEN_ANZAHL][DISP_ZEILE_LAENGE];

#define WITH_EEPROM_DATEN
#if    MICROCHIP_C18
    #ifdef WITH_EEPROM_DATEN
        #pragma romdata section_eeprom_data =0xf000ff
        unsigned char           rom     EE_DUMMY_BYTE1                   = PROG_VERSION;            // hier steht nichts drinn...
        /*unsigned char           rom     EE_DUMMY_BYTE2                   = 254;            // hier steht nichts drinn...
        unsigned char           rom     EE_DUMMY_BYTE3                   = 253;            // hier steht nichts drinn...
        unsigned char           rom     EE_DUMMY_BYTE4[]                = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};            // hier steht nichts drinn...*/
    #endif

    #pragma code
#else
    #ifdef WITH_EEPROM_DATEN

    __code   char __at(0xf000fe)  PrVer = PROG_VERSION;

    #endif
#endif


void main(void)
 {
unsigned char Flanke10Ms,Flanke100Ms,Flanke1000Ms;
unsigned char  KurzZwisch,i,*p;

MatrixTastenZeileAlt[0]=0;
MatrixTastenZeile[0]=0;
MatrixTastenZeileAlt[1]=0;
MatrixTastenZeile[1]=0;

INTCON = 0;

LATC = 0;
TRISC = 0; // wenn 0 dann als Ausgang definiert
Timer0Init();			 //Timer 0 Interrupt fr Zeitflanken Bildung
DisplayIn_Interrupt_Schritt =255;
#if  MICROCHIP_C18
memset(DisplayZeileRam,' ',sizeof(DisplayZeileRam));//sizeof(DisplayZeileRam));
#else
//memset(&DisplayZeileRam[0][0],0x3232,(sizeof(DisplayZeileRam))/2);//sizeof(DisplayZeileRam));
MemsetEigene(&DisplayZeileRam[0][0],' ',sizeof(DisplayZeileRam));
#endif
InterrupInit();
CursorAufPos = 255;
while(!Flanke100MsT)		//Zeit Verzgern vo Display INIT
;
DISPLAYTECH162_Init();
DisplayIn_Interrupt_ZeileNr=0;
DisplayIn_Interrupt_Schritt = 0;

while(1)
 {

	Flanke10Ms = Flanke10MsT;		//Flanke vom TimInterrupt bernehmen
	if (Flanke10Ms)
		Flanke10MsT = 0;
	Flanke100Ms = Flanke100MsT;
	if (Flanke100Ms)
		Flanke100MsT = 0;
	Flanke1000Ms = Flanke1000MsT;
	if (Flanke1000Ms)
		Flanke1000MsT = 0;



     //Matrixtastatur
	MatrixTastenZeile[0]=MatrixTastenZeileInterrupt[0];
	MatrixTastenZeile[1]=MatrixTastenZeileInterrupt[1];

	KurzZwisch=MatrixTastenZeileAlt[0]^MatrixTastenZeile[0];
	MatrixTastenZeilePlusFlanke[0]=KurzZwisch&MatrixTastenZeile[0];
	MatrixTastenZeileMinusFlanke[0]=KurzZwisch&MatrixTastenZeileAlt[0];
	MatrixTastenZeileAlt[0]=MatrixTastenZeile[0];

	KurzZwisch=MatrixTastenZeileAlt[1]^MatrixTastenZeile[1];
	MatrixTastenZeilePlusFlanke[1]=KurzZwisch&MatrixTastenZeile[1];
	MatrixTastenZeileMinusFlanke[1]=KurzZwisch&MatrixTastenZeileAlt[1];
	MatrixTastenZeileAlt[1]=MatrixTastenZeile[1];


for(p=&DisplayZeileRam[0][7],i=0;i<8;--p,++i)
{
   *p = ((MatrixTastenZeile[0]>>i)&1)+'0';
}

for(p=&DisplayZeileRam[1][7],i=0;i<8;--p,++i)
{
   *p = ((MatrixTastenZeile[1]>>i)&1)+'0';
}







	Flanke10Ms = 0;
	Flanke100Ms = 0;
	Flanke1000Ms = 0;

 }



}



void Timer0Init(void)
{
/*Takt vom 20 MHZ wird durch feste Teilung 4 auf 5 reduziert. 1 ZeitTick betrgt dabei 0.2 MikroSekund
 Fr erwnschte Zeit 1 MiliSekunden muss der Zhler mit 65536-5000 =60536 =  0xEC78 geladen werden, fr 10 Ms :65536-50000 = 15536 = 0x3CB0 */
	TMR0H = 0x3C;  //10 Ms :65536-50000 = 15536 = 0x3CB0 in Timer0 laden
	TMR0L = 0xB0;
	T0CONbits.T0CS = 0; 		//PIC-Takt als Quelle fr Timer0
	T0CONbits.T0PS0 = 1;		//Vorteiler Bit 0
	T0CONbits.T0PS1 = 1; 		//Vorteiler Bit 1
	T0CONbits.T0PS2 = 1; 		//Vorteiler Bit 2
	T0CONbits.PSA = 1;    ;		//1-Kein Vorteiler
	//T0CONbits.T0SE = 1 ;		//Flanke Auswahl vom Eingang wenn T0CONbits.T0CS = 1
	T0CONbits.T08BIT = 0 ;		//0 - 16 Bits Zhler,1 - 8 Bits Zhler
	T0CONbits.TMR0ON = 1 ;		//Timer ON

	Flanke10MsT = 0;		//ZeitFlanke vom Interrupt lschen
	Flanke100MsT = 0;
	Flanke1000MsT = 0;
	InterrupptZaehler1 = 0;
	InterrupptZaehler2 = 0;
	INTCON2bits.T0IP = 0;		//HIGH oder LOW TMR0 Overflow Interrupt Priority bit union FEHLER!!!
	INTCONbits.TMR0IE = 1 ;		//Timer0 Interrupt Enable
}
	/*Initialisierung fr DISPLAYTECH 162*/
/*                                            	 ;;
;; 4bit-Interface                             	 ;;
;; DB4-DB7:       LATCbits.LATC0-LATCbits.LATC3  ;;
;; RS:            LATCbits.LATC4                 ;;
;; E:             LATCbits.LATC5                 ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/

void DISPLAYTECH162_Init(void)
{
	/*
 	 * the delayNNtcy family of functions performs a
	 * delay of NN cycles. Possible values for NN are:
	 *   10  10*n cycles delay
	 *  100  100*n cycles delay
	 *   1k  1000*n cycles delay
	 *  10k  10000*n cycles delay
	 * 100k  100000*n cycles delay
	 *   1m  1000000*n cycles delay


	void delay10tcy(unsigned char) __wparam;
	void delay100tcy(unsigned char) __wparam;
	void delay1ktcy(unsigned char) __wparam;
	void delay10ktcy(unsigned char) __wparam;
	void delay100ktcy(unsigned char) __wparam;
	void delay1mtcy(unsigned char) __wparam;

	1 Million Zyklen sind 4 Millionen Takte. Bei 1 MHz ergeben sich 4 Sek. Wartezeit. Bei  20 MHz Takt ergibt 4Sek/20 -> 1/5 Sekunde Wartezeit.
	Bei 20 Mhz 1000000 Zyklen entsprechen 0.25 Sek = 250000 Mikrosekund -> ZyklenProMikrosekunde = 1000000/250000 = 100/25 = 4

	*/

	DISPLAYTECH162_SET_EnablePin = 0;
	DISPLAYTECH162_SET_Comand0_Daten1  = 0;
  	DISPLAYTECH162_SET_DataBit7 = 0;
	DISPLAYTECH162_SET_DataBit6 = 0;
	DISPLAYTECH162_SET_DataBit5 = 0;
	DISPLAYTECH162_SET_DataBit4 = 0;


	//Delay10KTCYx(100);
	delay1ktcy(80);  		//Warten Soll= 15 Ms Ist = 20MS -> 20000 Mikrosekunden -> 80000 Zyklen

	DISPLAYTECH162_SET_DataBit5 = 1;	//RS R/W DB7 DB6 DB5 DB4 DB3 DB2 DB1 DB0
	DISPLAYTECH162_SET_DataBit4 = 1;	//0   0   0   0   1   1   *   *   *   *

	DISPLAYTECH162_Enable();	//1 Enable setzen
	delay1ktcy(20);  		//Warten Soll= 4.1 Ms Ist = 5Ms -> 5000 Mikrosekunden -> 20000 Zyklen

	DISPLAYTECH162_Enable();	//2 Enable setzen
	delay1ktcy(20);  		//Warten Soll= 4.1 Ms Ist = 5Ms -> 5000 Mikrosekunden -> 20000 Zyklen

	DISPLAYTECH162_Enable();	//3 Enable setzen
	delay1ktcy(20);  		//Warten Soll= 4.1 Ms Ist = 5Ms -> 5000 Mikrosekunden -> 20000 Zyklen

	DISPLAYTECH162_SET_DataBit5 = 1;	//RS R/W DB7 DB6 DB5 DB4 DB3 DB2 DB1 DB0    4-Bit Modus wird eingeschaltet
	DISPLAYTECH162_SET_DataBit4 = 0;	//0   0   0   0   1   0   *   *   *   *


	DISPLAYTECH162_Enable();	//2 Enable setzen
	delay1ktcy(20);  		//Warten Soll= 4.1 Ms Ist = 5Ms -> 5000 Mikrosekunden -> 20000 Zyklen

	DISPLAYTECH162_Command(0b00000001); //Display clear
	delay1ktcy(20);  		//Warten Soll= 4.1 Ms Ist = 5Ms -> 5000 Mikrosekunden -> 20000 Zyklen

	DISPLAYTECH162_Command(0b00101000); //0b0011ZF00 Z-2 Zeilen F-Font 5x8

	DISPLAYTECH162_Command(0b00001100); //Display Ein / Cursor Aus / kein Blinken
	//DISPLAYTECH162_Command(0b00001101); //Display Ein / Cursor Aus / Blinken EIN
	////DISPLAYTECH162_Command(0b00001110); //Display Ein / Cursor EIN / kein Blinken
	//DISPLAYTECH162_Command(0b00001111); //Display Ein / Cursor EIN /Blinken EIN

	DISPLAYTECH162_Command(0b00000110); //0b000001IS I-Curso Inc/Decr S-Scrollen

}


void	DISPLAYTECH162_Enable(void)
 {
	DISPLAYTECH162_SET_EnablePin = 1;
	delay10tcy(1);
	DISPLAYTECH162_SET_EnablePin = 0;


 }

void	DISPLAYTECH162_Command(unsigned char command)
 {

	DISPLAYTECH162_SET_Comand0_Daten1 = 0;
	DISPLAYTECH162_SET_DataBit7 = (command>>7)&1;
	DISPLAYTECH162_SET_DataBit6 = (command>>6)&1;
	DISPLAYTECH162_SET_DataBit5 = (command>>5)&1;
	DISPLAYTECH162_SET_DataBit4 = (command>>4)&1;
	DISPLAYTECH162_Enable();
	delay10tcy(1);
	DISPLAYTECH162_SET_DataBit7 = (command>>3)&1;
	DISPLAYTECH162_SET_DataBit6 = (command>>2)&1;
	DISPLAYTECH162_SET_DataBit5 = (command>>1)&1;
	DISPLAYTECH162_SET_DataBit4 = (command)&1;
	DISPLAYTECH162_Enable();
	delay10tcy(50);			//200 : Delay 50 Sek


 }






/*Interrupt initialisieren*/
void InterrupInit(void)
 {

PIR1 = 0;			//InterruptFlags lschen
PIR2 = 0;			//InterruptFlags lschen
INTCONbits.TMR0IF = 0;          //Timer0 Interruptflag lschen
INTCONbits.INT0IF = 0 ; 	//External Interrupt Flag bit

RCONbits.IPEN = 1;//1;		//1 ja fr: interrupt priority
INTCONbits.GIEH = 1 ;		//Inerrupt HIGH Ein
INTCONbits.GIEL = 1 ;		//Inerrupt LOW  Ein

}


/*Interrupt High routine*/
#if  MICROCHIP_C18
	#pragma interrupt InterruptHigh
	void InterruptHigh(void) //interrupt 1
#else
	void InterruptHigh(void) __interrupt 1
#endif
{


if(PIR1bits.RCIF) //Zeichen ber RS232 empfangen
  {

	PIR1bits.RCIF = 0;
  }

}
void MemsetEigene(char *Ziel,char Zeichen,unsigned char Anzahl)
{
 unsigned char i;
 for(i=0;i<Anzahl;++i)
  *Ziel++ = Zeichen;
}

void Display_In_Interrupt(void)
{
 unsigned char ZwischByte;
    switch(DisplayIn_Interrupt_Schritt)
    {
        case 0:
            //PIC-Pins an Display als Ausgnge definieren
            DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_NO_ENABLE;//???1;
            DISPLAYTECH162_DatenComand_DEF_In1_Out0 = PIN_ALS_AUSGANG;
            DISPLAYTECH162_DataBit4_DEF_In1_Out0 = PIN_ALS_AUSGANG;
            DISPLAYTECH162_DataBit5_DEF_In1_Out0 = PIN_ALS_AUSGANG;
            DISPLAYTECH162_DataBit6_DEF_In1_Out0 = PIN_ALS_AUSGANG;
            DISPLAYTECH162_DataBit7_DEF_In1_Out0 = PIN_ALS_AUSGANG;

            //Cursor am Anfang einer Zeile setzen
            DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_NO_ENABLE;
            DISPLAYTECH162_SET_Comand0_Daten1 = DATEN_FUER_DISPLAY_ALS_COMMAND;

                DISPLAYTECH162_SET_DataBit7 = 1;//(command>>7)&1;
            if (DisplayIn_Interrupt_ZeileNr==0)
                DISPLAYTECH162_SET_DataBit6 = 0;//(command>>6)&1;
            else
                DISPLAYTECH162_SET_DataBit6 = 1;//(command>>6)&1;
                DISPLAYTECH162_SET_DataBit5 = 0;//(command>>5)&1;
                DISPLAYTECH162_SET_DataBit4 = 0;//(command>>4)&1;

                DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_ENABLE;
                DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_ENABLE;
                DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_ENABLE;
                //delay10tcy(1);
                DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_NO_ENABLE;
                DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_NO_ENABLE;
                DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_NO_ENABLE;

                DISPLAYTECH162_SET_DataBit7 = 0;
                DISPLAYTECH162_SET_DataBit6 = 0;
                DISPLAYTECH162_SET_DataBit5 = 0;
                DISPLAYTECH162_SET_DataBit4 = 0;

                DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_ENABLE;
                DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_ENABLE;
                DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_ENABLE;
                //delay10tcy(1);
                DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_NO_ENABLE;
                DisplayIn_Interrupt_ZeichenNr = 0;

                DisplayIn_Interrupt_Schritt = 1;
        break;
        case 1:

            DisplayIn_Interrupt_Zeichen = DisplayZeileRam[DisplayIn_Interrupt_ZeileNr][DisplayIn_Interrupt_ZeichenNr];
            if (CursorAufPos!=255)
             {
                 if(CursorAufPosInZeileNr==DisplayIn_Interrupt_ZeileNr)
                    {
                      if(CursorAufPos==DisplayIn_Interrupt_ZeichenNr)
                      {


                        if(EditBlinkZaehler>2)
                         {
                             DisplayIn_Interrupt_Zeichen =' ';
                           if (EditBlinkZaehler>=3)
                                EditBlinkZaehler = 0;
                         }
                        ++EditBlinkZaehler;
                      }
                    }
             }
              else
                EditBlinkZaehler = 0;

        	DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_NO_ENABLE;
            DISPLAYTECH162_SET_Comand0_Daten1 = DATEN_FUER_DISPLAY_ALS_ZEICHEN;                          //Daten an Display - Enable ist noch 0!
            DISPLAYTECH162_SET_DataBit7 = (DisplayIn_Interrupt_Zeichen>>7)&1;       //Obere 4 Bits
            DISPLAYTECH162_SET_DataBit6 = (DisplayIn_Interrupt_Zeichen>>6)&1;
            DISPLAYTECH162_SET_DataBit5 = (DisplayIn_Interrupt_Zeichen>>5)&1;
            DISPLAYTECH162_SET_DataBit4 = (DisplayIn_Interrupt_Zeichen>>4)&1;
            DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_ENABLE;
            DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_ENABLE;
            DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_ENABLE;
            //delay10tcy(1);
            DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_NO_ENABLE;
            DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_NO_ENABLE;
            DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_NO_ENABLE;
            DISPLAYTECH162_SET_DataBit7 = (DisplayIn_Interrupt_Zeichen>>3)&1;       //Obere 4 Bits
            DISPLAYTECH162_SET_DataBit6 = (DisplayIn_Interrupt_Zeichen>>2)&1;
            DISPLAYTECH162_SET_DataBit5 = (DisplayIn_Interrupt_Zeichen>>1)&1;
            DISPLAYTECH162_SET_DataBit4 = (DisplayIn_Interrupt_Zeichen)&1;
            DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_ENABLE;
            DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_ENABLE;
            DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_ENABLE;
            //delay10tcy(1);
            DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_NO_ENABLE;
            DisplayIn_Interrupt_ZeichenNr++;                            //nchstes Zeiche whlen
            if(DisplayIn_Interrupt_ZeichenNr==DISP_ZEILE_LAENGE)        //Alle Zeichen in einer Zeile schon ausgegeben?
                {
                    DisplayIn_Interrupt_ZeileNr++;                      //nchste Zeile auswhlen
                   if(DisplayIn_Interrupt_ZeileNr==DISP_ZEILEN_ANZAHL) //Alle Display Zeilen schon ausgegeben?
                       DisplayIn_Interrupt_ZeileNr = 0;
                       DisplayIn_Interrupt_Schritt = 2;
                }
        break;

        break;
        case 2:

DISPLAYTECH162_SET_EnablePin = DATEN_FUER_DISPLAY_NO_ENABLE;


TASTE0inMATRIXREIHE_PIN =   PIN_ALS_EINGANG;
TASTE1inMATRIXREIHE_PIN =   PIN_ALS_EINGANG;
TASTE2inMATRIXREIHE_PIN =   PIN_ALS_EINGANG;
TASTE3inMATRIXREIHE_PIN =   PIN_ALS_EINGANG;
TASTENMATRIXADRESSE0_PIN =  PIN_ALS_AUSGANG;
TASTENMATRIXADRESSE1_PIN =  PIN_ALS_AUSGANG;

TASTENMATRIXADRESSE0 = 0;
TASTENMATRIXADRESSE1 = 0;
TASTENMATRIXADRESSE0 = 0;
TASTENMATRIXADRESSE1 = 0;
TASTENMATRIXADRESSE0 = 0;
TASTENMATRIXADRESSE1 = 0;
TASTENMATRIXADRESSE0 = 0;
TASTENMATRIXADRESSE1 = 0;
ZwischByte = (TASTE0inMATRIXREIHE<<7)+(TASTE1inMATRIXREIHE<<6)+(TASTE2inMATRIXREIHE<<5)+(TASTE3inMATRIXREIHE<<4);

TASTENMATRIXADRESSE0 = 1;
TASTENMATRIXADRESSE1 = 0;
TASTENMATRIXADRESSE0 = 1;
TASTENMATRIXADRESSE1 = 0;
TASTENMATRIXADRESSE0 = 1;
TASTENMATRIXADRESSE1 = 0;
TASTENMATRIXADRESSE0 = 1;
TASTENMATRIXADRESSE1 = 0;
ZwischByte += (TASTE0inMATRIXREIHE<<3)+(TASTE1inMATRIXREIHE<<2)+(TASTE2inMATRIXREIHE<<1)+TASTE3inMATRIXREIHE;

MatrixTastenZeileInterrupt[0] = ZwischByte;



TASTENMATRIXADRESSE0 = 0;
TASTENMATRIXADRESSE1 = 1;
TASTENMATRIXADRESSE0 = 0;
TASTENMATRIXADRESSE1 = 1;
TASTENMATRIXADRESSE0 = 0;
TASTENMATRIXADRESSE1 = 1;
TASTENMATRIXADRESSE0 = 0;
TASTENMATRIXADRESSE1 = 1;
ZwischByte = (TASTE0inMATRIXREIHE<<7)+(TASTE1inMATRIXREIHE<<6)+(TASTE2inMATRIXREIHE<<5)+(TASTE3inMATRIXREIHE<<4);


TASTENMATRIXADRESSE0 = 1;
TASTENMATRIXADRESSE1 = 1;
TASTENMATRIXADRESSE0 = 1;
TASTENMATRIXADRESSE1 = 1;
TASTENMATRIXADRESSE0 = 1;
TASTENMATRIXADRESSE1 = 1;
TASTENMATRIXADRESSE0 = 1;
TASTENMATRIXADRESSE1 = 1;
ZwischByte += (TASTE0inMATRIXREIHE<<3)+(TASTE1inMATRIXREIHE<<2)+(TASTE2inMATRIXREIHE<<1)+TASTE3inMATRIXREIHE;
MatrixTastenZeileInterrupt[1] = ZwischByte;



DisplayIn_Interrupt_Schritt = 0;

        break;
        default:
            ;
        break;
    }



}


/*Interrupt Low routine*/
#if  MICROCHIP_C18
	#pragma interrupt InterruptLow
	void InterruptLow(void) //interrupt 2
#else
	void InterruptLow(void) __interrupt 2
#endif
{
 if (INTCONbits.T0IF)
 {
	//TMR0H = 0x3C;  //10 Ms :65536-50000 = 15536 = 0x3CB0 in Timer0 laden; Der Timer arbeitet mit Frequenz = 20Mhz/4. Ein TaktImpils = 0.2 MikroSekund
	//TMR0L = 0xB0; // 10 Ms -> sind 50000 Impulse.
	TMR0H = 0xEC;
    TMR0L = 0x78;
    ++InterrupptZaehler;
    if(InterrupptZaehler>=10)
    {
     InterrupptZaehler=0;
	 Flanke10MsT = 10;
	++InterrupptZaehler1;
	if (InterrupptZaehler1>=10)
	   {
		InterrupptZaehler1=0;
		Flanke100MsT=1;
	    }
	++InterrupptZaehler2;
	if (InterrupptZaehler2>=100)
	   {
		InterrupptZaehler2=0;
		Flanke1000MsT=1;
	    }
	//INTCONbits.TMR0IF = 0;
	INTCONbits.T0IF = 0;
    Display_In_Interrupt();
    }
    else
     INTCONbits.T0IF = 0;



 }



}
